﻿Imports Infragistics.Win.UltraWinGrid

Public Class Form1

    'Dim inAfterHeaderCheckStateChanged = False
    Dim inSynchSelection = False
    Dim inSynchHeader = False
    Dim allowSelectionChange = False

    Private Sub UltraGrid1_InitializeLayout(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout
        Dim band As UltraGridBand
        Dim col As UltraGridColumn

        band = e.Layout.Bands(0)
        band.Override.HeaderCheckBoxSynchronization = HeaderCheckBoxSynchronization.None

        For Each col In band.Columns
            If col.Key = "Select" Then
                col.CellActivation = Activation.ActivateOnly
                col.Header.CheckBoxVisibility = HeaderCheckBoxVisibility.WhenUsingCheckEditor
            Else
                col.CellActivation = Activation.Disabled
            End If
        Next

        Me.UltraGrid1.Selected.Rows.Clear()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.UltraGrid1.DataSource = Me.CreateTable()
    End Sub

    Private Function CreateTable() As DataTable
        Dim dt1 As New DataTable()
        dt1.Columns.Add("Select", GetType(Boolean))
        dt1.Columns.Add("Data")

        dt1.Rows.Add(New Object() {False, "AAA"})
        dt1.Rows.Add(New Object() {False, "AAA"})
        dt1.Rows.Add(New Object() {False, "BBB"})
        dt1.Rows.Add(New Object() {False, "BBB"})
        dt1.Rows.Add(New Object() {False, "AAA"})

        Return dt1

    End Function

    'Private Sub UltraGrid1_BeforeHeaderCheckStateChanged(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinGrid.BeforeHeaderCheckStateChangedEventArgs) Handles UltraGrid1.BeforeHeaderCheckStateChanged
    '    e.Cancel = Me.inAfterHeaderCheckStateChanged
    'End Sub

    Private Sub UltraGrid1_AfterHeaderCheckStateChanged(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinGrid.AfterHeaderCheckStateChangedEventArgs) Handles UltraGrid1.AfterHeaderCheckStateChanged
        'Try
        '    Me.inAfterHeaderCheckStateChanged = True
        Me.SynchSelectionToHeaderCheckState(e.Rows, e.Column)
        'Finally
        '    Me.inAfterHeaderCheckStateChanged = False
        'End Try
    End Sub


    Private Sub SynchSelectionToHeaderCheckState(ByVal rows As RowsCollection, ByVal column As UltraGridColumn)

        If Me.inSynchHeader Then
            Return
        End If

        Dim originalAllowSelection = Me.allowSelectionChange
        Try
            Me.inSynchSelection = True
            Me.allowSelectionChange = True
            Dim checkBoxValue As Boolean = column.GetHeaderCheckedState(rows) = CheckState.Checked
            If Not checkBoxValue Then
                Me.UltraGrid1.Selected.Rows.Clear()

                For Each row In rows
                    row.Cells(column).Value = False
                Next
            Else
                For Each row In rows
                    If row.Cells("Data").Value = "AAA" Then
                        row.Cells(column).Value = True
                    End If
                Next

            End If

        Finally
            Me.inSynchSelection = False
            Me.allowSelectionChange = originalAllowSelection
        End Try
    End Sub

    Private Sub SynchHeaderToSelection(ByVal rows As RowsCollection, ByVal column As UltraGridColumn)

        If Me.inSynchSelection Then
            Return
        End If

        Try
            Me.inSynchHeader = True

            Dim allTrue As Boolean = True
            Dim allFalse As Boolean = True
            For Each row As UltraGridRow In Me.UltraGrid1.Selected.Rows
                If (row.Cells(column).Value = True) Then
                    allFalse = False
                Else
                    allTrue = False
                End If
            Next

            Dim checkedState As CheckState = CheckState.Indeterminate

            If allFalse Then
                checkedState = CheckState.Unchecked
            ElseIf allTrue Then
                checkedState = CheckState.Unchecked
            End If

            column.SetHeaderCheckedState(rows, checkedState)
        Finally
            Me.inSynchHeader = False

        End Try


    End Sub

    Private Sub UltraGrid1_ClickCell(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinGrid.ClickCellEventArgs) Handles UltraGrid1.ClickCell
        e.Cell.Value = Not e.Cell.Value
    End Sub

    Private Sub UltraGrid1_BeforeSelectChange(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinGrid.BeforeSelectChangeEventArgs) Handles UltraGrid1.BeforeSelectChange
        e.Cancel = Not Me.allowSelectionChange
    End Sub

    Private Sub UltraGrid1_AfterCellUpdate(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinGrid.CellEventArgs) Handles UltraGrid1.AfterCellUpdate
        Dim originalAllowSelection = Me.allowSelectionChange
        Try

            Me.allowSelectionChange = True
            e.Cell.Row.Selected = e.Cell.Value
            Me.SynchHeaderToSelection(e.Cell.Row.ParentCollection, e.Cell.Column)
        Finally
            Me.allowSelectionChange = originalAllowSelection
        End Try
    End Sub

End Class
